/*
 * display_data.hpp
 *
 *  Created on: 18 mars 2015
 *      Author: dominique
 */

#ifndef SRC_DISPLAY_DATA_HPP_
#define SRC_DISPLAY_DATA_HPP_

#include "roles.hpp"

/**
 *   affiche le premier triangle de la liste
 */
void display_first_triangle(
		 	 	 	 	 	const TransactionTable& tt,
							const vector<int>& list_transactions,
							const vector<string>& initial_objects_names) ;


void display_extension_abstraite(
								 const Tvertice_identifiers_set& objects,
								 const vector<string>& objects_names
						  	  	) ;


void display_extension_abstraite(
								 const Troles_set& roles,
								 const vector<string>& objects_names
						  	  	) ;

void display_objects_names(
							const set<int>& initial_objects,
							const vector<string>& objects_names) ;

void display_object_name(
							const int object,
							const vector<string>& objects_names
						) ;

void display_objects_names(
							const vector<int>& initial_objects,
							const vector<string>& objects_names) ;


void outputOriginalPatternCerr(
							   set_t pattern,
							  const vector<string>& items_names
				              ) ;

void outputOriginalPattern(
							set_t pattern,
							const vector<string>& items_names
				          ) ;

void outputOriginalPattern2(
							set_t pattern,
							const vector<string>& items_names,
							const set_t& permutation
				          ) ;


void outputPattern(
				   bool show_tids, TransactionTable& tt,
				   const Toccurences& occs,
				   set_t pattern, int set_support
				  ) ;


void outputLocalPattern(
						 set_t closed_pattern_cci,
						 const vector<string>& items_names
						) ;


/**
 * each Transaction of tt contains a list of adjacences.
 * each list of adjacences contains the indices of the transactions in tt
 * that are connected to the current transaction
 */
void print_selection_initial_objects(const TransactionTable& tt,
									 const set<element_t>& list) ;




#endif /* SRC_DISPLAY_DATA_HPP_ */
