//
//  AH.c
//  
//
//  Abstraction hub-autorite avec  aut,hub en arguments
//  d'un fichier au format .dot simplifie' (voir ci-dessous)
//  dont les sommets sont etiqete's sous la forme "numero:id"
//  extrait typiquemnt d'un fichier  .dot sorti par  minerLC (par -save_graphs)
//
//  On sort la liste des sommets (numeéro+, d)autorites avec leur degre' d'autorite' et de hub
//  on s'en sert sur un fichier déjà abstrait ou un fichier non abstrait
//  puisque l'abstraction est recalcule'e

//#include "AH.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define NMAX 100000


static int compare (void const *a, void const *b);

/* usage du quicksort *
 qsort (tab, sizeof tab / sizeof *tab, sizeof *tab, compare);
 */
int main(int argc, char* argv[]){
    int convergence;
    int collapse;
    char chaine[1000],vraiId[1000];
    char s[2];
    int dp[NMAX],dm[NMAX],dpVers[NMAX],dmDe[NMAX];
    int indSommets[NMAX], sommets[NMAX], id[NMAX];
    int i,is,ip,k,pos,k1;
    int g,d;
    int nbSommets;
    int a;
    int nbArcs;
    int arcs[10000][2];
    int size, sizeA,sizeH;
    int hubLast;
    int lA[NMAX],lH[NMAX];
    int hub;
    int auth;
    //    printf("auth %d \n",auth);
    
    auth=atoi(argv[1]);// lecture degre autorite
    hub=atoi(argv[2]);// lecture degre hub`
    
    // lecture d'un fichier  graphe sommets-arcs : fichier d'eesai essaiGrepNew.txt
    // format extrait de  .dot :
    // sommets  0 [label= "0:1:"];
    //#
    //arcs      0 -> 1 ;
    //#
    
    // lecture sommets
    scanf("%s", chaine);
    i=-1;

    while (chaine[0] != '#'){
       
        i++;
        sommets[i]=atoi(chaine);
        scanf("%s", chaine);scanf("%s", chaine);
        for(k=0;k<strlen(chaine);k++)
        if (chaine[k]==':'){
            pos=k+1;
            break;
        }
        k=pos;
        k1=0;
        while( k<strlen(chaine) && chaine[k]!='"'){
            vraiId[k1]=chaine[k];
            k++;k1++;
        }
        vraiId[k1]='\0';
        printf("%d,",sommets[i]);
//        printf("%d ", sommets[i]);
        indSommets[sommets[i]]=i;
        id[i]=atoi(vraiId);
        printf("%d\n",id[i]);

//         Exemple
//         i = 0 1 2
//         sommets[i] = 4 7 9
//         indSommets[4]= 0
        scanf("%s", chaine);
    }
    printf("\n");
    printf("lecture sommets ok \n");
    nbSommets=i+1;
    

    
    // lecture arcs et calcul dp dm
    
    for (i=0;i< nbSommets;i++){
        dp[i]=0;
        dm[i]=0;
    }
    scanf("%s", chaine);
    a=-1;
    while (chaine[0] != '#'){
        
        a++;
        g = atoi(chaine); scanf("%s", chaine);scanf("%s", chaine);
        d = atoi(chaine); scanf("%s", chaine);

//        printf("%d %d \n", g,d);
        arcs[a][0]=g;arcs[a][1]=d;
        dp[indSommets[g]]++;
        dm[indSommets[d]]++;
        
//        printf("  %d d+ %d  %d d- %d \n", g, dp[indSommets[g]], d, dm[indSommets[d]]);
        scanf("%s", chaine);
    }
    nbArcs=a+1;
    printf("lecture arcs ok \n");
    
    // calcul dA dH par convergence des suites dmDe et dpVers
    

//        printf(" auth %d hub %d \n ", auth,hub);
    convergence=0; // en principe une seule iteration
    while (! convergence){
        // nouvelles valeurs de dpVers et dmDe
        for(i=0;i<nbSommets;i++){
            dpVers[i]=0;
            dmDe[i]=0;
        }
        for(a=0;a<nbArcs;a++){
            
            g=arcs[a][0];d=arcs[a][1];
            if (dp[indSommets[g]]>=hub)
                dmDe[indSommets[d]]++;
            if (dm[indSommets[d]]>=auth)
                dpVers[indSommets[g]]++;
            
        }
        
        // convergence ou non ?
        convergence=1;
        printf(" -- iteration -- \n");
        for(i=0;i<nbSommets;i++){
//                printf(" s%d \t dH %d \t dHOld %d\t dA %d dAOld %d\n",sommets[i], dpVers[i], dp[i], dmDe[i], dm[i] );
            if ((dpVers[i] != dp[i]) || (dmDe[i] != dm[i]))
                convergence = 0;
        }
        printf(" -- convergence-- %d \n", convergence);
        // Preparation prochaine iteration
        for(i=0;i<nbSommets;i++){
            dp[i]=dpVers[i];
            dm[i]=dmDe[i];
        }
    }
    // collapse quand le sous-graphe devient vde
    collapse = 1;
    for(i=0;i<nbSommets;i++){
        
        if ((dpVers[i] != 0) || (dmDe[i] != 0)){
            collapse = 0;
            
        }
    }
    printf("collapse  %d\n", collapse );
    if (  collapse ){
        printf(" extension HA vide \n");
        return 0;
    }
    size= sizeA= sizeH= 0;
    for(i=0;i<nbSommets;i++){
        if ( dpVers[i] >= hub || dmDe[i] >=auth){
//                    printf(" s%d \t dA %d \t  dH %d \n",sommets[i], dmDe[i], dpVers[i] );
            if ( dpVers[i] >= hub){
                lH[sizeH]=sommets[i]; // i= indice sommets[i]= sommet
//                    printf(" sommet i = %d \n", sommets[i]);
                sizeH++;
            }
            if ( dmDe[i] >= auth){
                lA[sizeA]=sommets[i];
                sizeA++;
            }
            size++;
        }
        
    }
//           printf(" sizeA %d sizeH %d size %d \n", sizeA,sizeH,size);

    printf("A\n  %d H %d sizeA %d sizeH %d size %d \n", auth, hub, sizeA,sizeH,size);
    
    // degres d'autorite et de hub
    printf("A\n sommet , id, dA, dH \n");
    for(i=0;i<sizeA;i++){
        printf("%d, %d,  ",lA[i],id[indSommets[lA[i]]]);
        printf("%d, ",dmDe[ indSommets[lA[i]] ]);
        printf("%d ",dpVers[ indSommets[lA[i]] ]);
        printf("\n");
    }
    
    
    
    printf("H\n sommet, id ,dA , dH \n");
    for(i=0;i<sizeH;i++){
        printf("%d, %d,  ",lH[i],id[indSommets[lH[i]]]);
        printf("%d, ",dmDe[ indSommets[lH[i]] ]);
        printf("%d ",dpVers[ indSommets[lH[i]] ]);
        printf("\n");
    }
    printf("\n");
    
    // sommets
    printf("A\n");
    for(i=0;i<sizeA;i++)
        printf("%d ",lA[i]);
    printf("\n");
    
    printf("H\n");
    for(i=0;i<sizeH;i++)
        printf("%d ",lH[i]);
    printf("\n");
    return 0;
}
/* fonction utilisateur de comparaison fournie a qsort() */
static int compare (void const *a, void const *b)
{
    /* definir des pointeurs type's et initialise's
     avec les parametres */
    int const *pa = a;
    int const *pb = b;
    
    /* evaluer et retourner l'etat de l'evaluation (tri croissant) */
    return *pa - *pb;
}
