/*
 * statsModularity.cpp
 *
 *  Created on : 1 juin 2018
 *  Author     : Dominique Bouthinon
 */

#include "statsModularity.hpp"

statsModularity::statsModularity()
{
	this->nbLm  = 0 ;
	this->nbLme = 0 ;
	this->nec   = 0 ;
	this->f     = 0 ;
}

statsModularity::~statsModularity()
{
}

int statsModularity::getNec()
{
	return this->nec ;
}

int statsModularity::getNbLm()
{
	return this->nbLm ;
}

int statsModularity::getNbLme()
{
	return this->nbLme ;
}

int statsModularity::getF()
{
	return this->f ;
}


void statsModularity::incNbLm()
{
	(this->nbLm)++ ;
}


void statsModularity::incNbLme()
{
	(this->nbLme)++ ;
}

void statsModularity::incNec()
{
	(this->nec)++ ;
}

void statsModularity::incF()
{
	(this->f)++ ;
}

void statsModularity::decNbLme()
{
	(this->nbLme)-- ;
}

void statsModularity::decF()
{
	(this->f)-- ;
}


void statsModularity::decNbLm()
{
	(this->nbLm)-- ;
}


void statsModularity::decNec()
{
	(this->nec)-- ;
}


void statsModularity::setNec(int nec)
{
	this->nec = nec ;
}

void statsModularity::setF(int f)
{
	this->f = f ;
}

