/*
 * COMMON_FUNCTIONS.HPP
 *
 *  Author: Dominique Bouthinon (LIPN, Université Paris 13)
 */

#ifndef __COMMON_SUPPORTS_FUNCTIONS_HPP_
#define __COMMON_SUPPORTS_FUNCTIONS_HPP_


#include "types_graph.hpp"
// #include "graph.hpp"

using namespace std ;

			// retourne aleatoirement un entier entre min (inclus) et max(exclus)
int rand_min_max(int min, int max) ;

			// tire au hasard et sans remise n elements dans vertices
			// les elements tirés sont placés dans drawn_vertices
			// et déplacés vers le haut de vertices
void get_random_vertices(
						 int n,
						 Tvertice_identifier vertices[],
						 int& limite_sup_tirage,
						 Tvertice_identifiers_set& drawn_vertices
						) ;


			// tire au hasard SANS LES RETIRER n elements dans vertices
			// les elements tirés sont placés dans drawn_vertices
void get_random_vertices2(
						 int n,
						 Tvertice_identifier vertices[],
						 int m,
						 Tvertice_identifiers_set& drawn_vertices
						) ;

void displayTab(Tvertice_identifier t[], int n) ;

#endif
